SystemOrganization addCategory: #'CS528-SkeetManager'!

Object subclass: #ClassType
	instanceVariableNames: 'name average'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:36'!
newAAAClass: anAverage
	^self new name: #'AAA Class' average: anAverage.
	! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:36'!
newAAClass: anAverage
	^self new name: #'AA Class' average: anAverage.
	! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:37'!
newAClass: anAverage
	^self new name: #'A Class' average: anAverage.
	! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:37'!
newBClass: anAverage
	^self new name: #'B Class' average: anAverage.
	! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:37'!
newCClass: anAverage
	^self new name: #'C Class' average: anAverage.
	! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:37'!
newDClass: anAverage
	^self new name: #'D Class' average: anAverage.
	! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:37'!
newEClass: anAverage
	^self new name: #'E Class' average: anAverage.
	! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:43'!
newNCClass: anAverage
	^self new name: #'NC Class' average: anAverage.
	! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:39'!
average
	^ average.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:39'!
average: anAverage
	average := anAverage.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:39'!
name
	^name.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:39'!
name: aName
	name := aName.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:39'!
name: aName average: anAverage
	name := aName .
	average  := anAverage! !

Object subclass: #ConcurrentType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:58'!
newActiveMilitary
	^ self new name: #'Active Military'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:10'!
newJunior
	^ self new name: #'Junior'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:57'!
newLady
	^ self new name: #'Lady'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:58'!
newRetiredMilitary
	^ self new name: #'Retired Military'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:11'!
newSenior
	^ self new name: #'Senior'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:10'!
newSubJunior
	^ self new name: #'Sub Junior'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:11'!
newSubSenior
	^ self new name: #'Sub Senior'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:11'!
newSubSubSenior
	^ self new name: #'Sub Sub Senior'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:11'!
newTripleSubSenior
	^ self new name: #'Triple Sub Senior'! !

!ConcurrentType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:11'!
newVeteran
	^ self new name: #'Veteran'! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:59'!
name
	^ name.! !

Object subclass: #DatabaseWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:25'!
connect
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:22'!
connectionFailed
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:25'!
disconnect
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:50'!
saveEvent: anEvent
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:50'!
saveScore: aScore
	 ^ self subclassResponsibility.! !

!DatabaseWrapper methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 16:50'!
saveUser: aUser
	 ^ self subclassResponsibility.! !

Object subclass: #Event
	instanceVariableNames: 'name shooters scores scoreFormat honors shootoffs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Event subclass: #CompositeEvent
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Event class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 18:02'!
newEventWithName: aName
	^ self new eventWithName: aName.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:21'!
addShooter: aShooter
	shooters add: aShooter.
	scores at: (aShooter name) put: (self getZeroScore).
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:23'!
createHonors
	self createHonorsFor: 1.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:29'!
createHonorsFor: aNumber
	"Creates the list of Honor objects given how many places will exist. This can be done once all shooters have been entered for an Event, but before all scores are entered for the event."
	.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:16'!
eventWithName: aName
	name:= aName.
	shooters := Collection new.
	scores := Dictionary new. "key is the name of a shooter. Value is a collection of scores."
	scoreFormat := Collection new add: 25; add: 25; add:25 ; add: 25. "this is just a collection. Length of the collection specifies the number of rounds. Value of each element is the maximum score that can be entered for each round"
	shootoffs  := Collection new.
	honors := Collection new.
	
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:34'!
generateHonors
	"I attempt to assign the winner of each already created honor. If there are ties, I generate shootoffs."
	.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:33'!
generateShootOffFor: anHonor Between: someShooters
	"Generates a single shootoff for a particular honor between a collection of shooters. It adds the shootoff to the Event's Collection of shootoffs."
	.! !

!Event methodsFor: 'helper methods' stamp: 'BiplabDeka 7/5/2013 14:20'!
getZeroScore
	" return a collection of zeros that is the same length as the score format"
	|zeroscore|
	zeroscore := Collection new.
	scoreFormat do: [ :score | zeroscore add: 0].
	
	^ zeroscore.
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
honors 
	^honors.! !

!Event methodsFor: 'helper methods' stamp: 'BiplabDeka 7/5/2013 14:14'!
isScoreValid: aScore
	|bool|
	bool := true.
	( aScore length == scoreFormat length ) ifFalse:  [bool := false] ifTrue: [
		aScore with: scoreFormat collect: [:score :bound | (score > bound) ifTrue: [bool:= false]]
		].
	
	

	^bool! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
name 
	^name.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:06'!
removeShooter: aShooter
	shooters remove: aShooter.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:15'!
setScore: aScore for: aShooter
	(self isScoreValid: aScore) ifTrue: [ 
		scores at: (aShooter name ) put: aScore.
	]! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
shooters
	^shooters.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
shootoffs
	^shootoffs.! !

Event subclass: #RealEvent
	instanceVariableNames: 'eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Object subclass: #EventType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!EventType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/3/2013 16:20'!
new12ga
	^self new name: #'12ga'.! !

!EventType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/3/2013 16:20'!
new20ga
	^self new name: #'20ga'.! !

!EventType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/3/2013 16:20'!
new28ga
	^self new name: #'28ga'.! !

!EventType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/3/2013 16:20'!
new410bore
	^self new name: #'410bore'.! !

!EventType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/3/2013 16:21'!
newDoubles
	^self new name: #'doubles'. ! !

!EventType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/3/2013 16:21'!
name: aSymbol
	name := aSymbol.! !

Object subclass: #Honor
	instanceVariableNames: 'event type positions winners'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
event
	^event.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:49'!
positions 
	^positions.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
type 
	^type.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:49'!
winners 
	^winners.! !

Object subclass: #Shoot
	instanceVariableNames: 'name shooters events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shoot class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:54'!
newShootWithName: aName 	
	^ self new shootWithName: aName.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addEvent: anEvent
	events add: anEvent.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addShooter: aShooter 
	shooters add: aShooter.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:55'!
shootWithName: aName
	name:= aName.
	shooters := Collection new.
	events := Collection new.! !

Object subclass: #Shooter
	instanceVariableNames: 'uuid firstName lastName middleName dob membershipNumber classifications concurrents address phone email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shooter class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:32'!
newShooterFirst: first middle: middle last: last
	^ self new firstName: first middleName: middle lastName: last.! !

!Shooter methodsFor: 'concurrent related' stamp: 'BiplabDeka 7/5/2013 14:59'!
addConcurrent: aConcurrent 
	concurrents add: aConcurrent name.
! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
address
	^ address.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
averageFor: anEventType
	^ nil.! !

!Shooter methodsFor: 'concurrent related' stamp: 'BiplabDeka 7/5/2013 14:59'!
belongsToConcurrent: aConcurrent 
	^ concurrents contains: (aConcurrent name).
! !

!Shooter methodsFor: 'class related' stamp: 'HenryDuwe 7/4/2013 14:13'!
classFor: anEventType
	^ nil.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:34'!
dob: aDate  	
	dob := aDate.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
email  
	^ email.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:59'!
firstName: first middleName: middle lastName: last
	firstName:= first.
	middleName:= middle .
	lastName:= last.
	dob:= Date newDay: 1 month:1  year:1900.
	address:='your address'.
	membershipNumber:=0.
	uuid:= first+'_'+middle+'_'+last.
	 classifications := Dictionary new. " key is event name. value is a Class type."
	concurrents := Collection new. "list of concurrent objects stored as names"
	 phone := 1112223333.
	email := 'yourname@example.com'
	 ! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:43'!
getClass: anEvent 
	" return a class is event is present. else return a NC with avergae zero"
	^ classifications at: (anEvent name) ifAbsent: (ClassType newNCClass: 0) .! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/4/2013 17:33'!
lastName: last 	
	lastName := last.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:35'!
membershipNumber: aNumber  	
	membershipNumber := aNumber.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:33'!
middleName: middle 	
	middleName := middle.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:12'!
name
	^name.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
phone 
	^ phone.! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/5/2013 14:45'!
setClass: aClass forEvent: anEvent
	
	 classifications at: (anEvent name) put: (aClass) .! !

Object subclass: #Shootoff
	instanceVariableNames: 'shooters resolved honor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
honor 
	^honor.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
resolved
	^resolved.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:42'!
resolvedWith:  someShooters 
	shooters := someShooters.
	resolved := true.
	"AND SOME MORE THINGS, such as calling honor to assign the winners, etc."! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
shooters
	^shooters.! !
